/*
 *--- PCommand.h ----------------------------------------------------------
 * Copyright (c) 1995-96 Adobe Systems Incorporated.  All rights reserved.
 * Created on Thu, Oct 12, 1995 @ 9:54 PM by Paul Ferguson.
 *
 * Description:
 *-------------------------------------------------------------------------
 */
#ifndef __PCommand__
#define __PCommand__

#ifdef __MWERKS__
#pragma once
#endif

#include <stdlib.h>

#include "PCallback.h"
#include "PMCommands.h"

class PRequestBuf;

class PCommand : public PCallback
{

public:

	PCommand(ePMCommand op);								// command with no params
	PCommand(ePMCommand op, short aShort);					// command with short param
	PCommand(ePMCommand op, long aLong);					// command with long param
	PCommand(ePMCommand op, const char * aString);			// command with single string command
	PCommand(ePMCommand op, void * aRawBuf, size_t theLen);	// command with a fully formed request buffer with length
	PCommand(ePMCommand op, PRequestBuf& request);			// command with a request buffer

private:

	PCommand();
	void DoCommand(ePMCommand op);
};

#endif

// end of PCommand.h
