/*
 *--- PPluginCall.h -------------------------------------------------------
 * Copyright (c) 1995-96 Adobe Systems Incorporated.  All rights reserved.
 * Created on Thu, Oct 12, 1995 @ 9:50 PM by Paul Ferguson.
 *
 * Description:
 *-------------------------------------------------------------------------
 */
#ifndef __PPluginCall__
#define __PPluginCall__

#include "PMTypes.h"
#include "PMCQErrs.h"

class PPluginCall
{

public:

	PPluginCall();

	void			Dispatch();
	void			BuildErrorMessages(const char * errText, const char * cantText = NULL);

	short			GetOpCode()  { return sPB->opCode; }
	unsigned long	GetSubCode() { return sPB->subCode; }

	void *			GetPluginData() 		{ return sPMMessage->pPlugInData; }
	void			SetPluginData(void * h)	{ sPMMessage->pPlugInData = h; }

	operator		const sPMParamBlock&() const { return *sPB; }
	
protected:

	// Your subclass should override any of these that you want to handle.
	virtual void	DoLoad() {};
	virtual void	DoRegister() {};

	virtual void	DoInvoke() {};

	virtual void	DoEvent() {};
	virtual void	DoSysEvent() {};

	virtual void	DoAcquireInterface() {};
	virtual void	DoReleaseInterface() {};
	
	virtual void	DoUnload() {};
	virtual void	DoShutdown() {};

	static sPMParamBlockPtr	sPB;
	static PMMessage *		sPMMessage;

private:

	// This class and its subclasses cannot be copied.
	PPluginCall(PPluginCall&);
	PPluginCall& operator=(const PPluginCall&);
};

#endif

// end of PPluginCall.h
