/*
 *--- PQuery.h ------------------------------------------------------------
 * Copyright (c) 1995-96 Adobe Systems Incorporated.  All rights reserved.
 * Created on Thu, Oct 12, 1995 @ 9:47 PM by Paul Ferguson.
 *-------------------------------------------------------------------------
 */
#ifndef __PQuery__
#define __PQuery__

#ifdef __MWERKS__
#pragma once
#endif

#include <stdlib.h>

#include "PMQueries.h"
#include "PCallback.h"
#include "PReplyBuf.h"		// many classes use a PReplyBuf, so include the header here

class PRequestBuf;

class PQuery : public PCallback
{

public:
	
	// Common query types (see PShortQuery.h, PBoolQuery.h, etc.)
	PQuery(ePMQuery op, short & aShort);
	PQuery(ePMQuery op, long & aLong);
	PQuery(ePMQuery op, PMHandle & aHandle);
	PQuery(ePMQuery op, void * aBuf, size_t len);
	PQuery(ePMQuery op, PRequestBuf & aRequest, short & aShort);
	PQuery(ePMQuery op, PRequestBuf & aRequest, long & aLong);
	PQuery(ePMQuery op, PRequestBuf & aRequest, PMHandle & aHandle);
	PQuery(ePMQuery op, PRequestBuf & aRequest, void * aBuf, size_t len);

private:

	void DoQuery(ePMQuery op);
	
	void SetRequestBlock(PRequestBuf & aRequest);
	void ClearRequestBlock();
};

#endif

// end of PQuery.h
