/*
 *--- PReplyBuf.h ---------------------------------------------------------
 * Copyright (c) 1995-96 Adobe Systems Incorporated.  All rights reserved.
 * Created on Thu, Oct 19, 1995 @ 8:18 PM by Paul Ferguson.
 *-------------------------------------------------------------------------
 */
#ifndef __PReplyBuf__
#define __PReplyBuf__

#ifdef __MWERKS__
#pragma once
#endif

#include "PMTypes.h"


class PReplyBuf
{

public:

	PReplyBuf(const char * ch);

	PReplyBuf& operator>> (const char ** aStringRef);	// Just set char * and scan over the string.
	PReplyBuf& operator>> (char * aString);				// Copy the C string.
	PReplyBuf& operator>> (unsigned char * aString);	// Copy the Pascal string.
	PReplyBuf& operator>> (short& aShort);
	PReplyBuf& operator>> (unsigned short& aShort);
	PReplyBuf& operator>> (long& aLong);
	PReplyBuf& operator>> (unsigned long& aLong);

	void		Reset() { curCh = bufStart; }
	
	operator const char *() { return curCh; }

private:

	const char	* bufStart;
	const char	* curCh;

	PReplyBuf();
	PReplyBuf(PReplyBuf&);
	PReplyBuf&	operator=(const PReplyBuf&);
};

#endif

// end of PReplyBuf.h
