/*
 *--- PRequestBuf.h -------------------------------------------------------
 * Copyright (c) 1995-96 Adobe Systems Incorporated.  All rights reserved.
 * Created on Thu, Oct 19, 1995 @ 8:17 PM by Paul Ferguson.
 *-------------------------------------------------------------------------
 */
#ifndef __PRequestBuf__
#define __PRequestBuf__

#include <string.h>
#ifdef __MWERKS__
#pragma once
#endif

#include "PMTypes.h"

class PRequestBuf
{
public:

	PRequestBuf(size_t size);
	PRequestBuf(void * h);

	virtual ~PRequestBuf();

	PRequestBuf& operator<< (short aShort);
	PRequestBuf& operator<< (unsigned short aShort);
	PRequestBuf& operator<< (long aLong);
	PRequestBuf& operator<< (unsigned long aLong);	
	PRequestBuf& operator<< (const char * aString);				// C string
	PRequestBuf& operator<< (const unsigned char * aString);	// Pascal string
	PRequestBuf& operator<< (PRequestBuf& aBuf);				// Append a buffer

	operator const char *() const { return bufPtr; }
	
	size_t		Size() const { return (long) curCh - (long) bufPtr; }
	
protected:

private:

	char 		* bufHdl;
	char		* curCh;		
	char		* bufPtr;		// this should not change after construction
	
	PRequestBuf(PRequestBuf&);
	PRequestBuf& operator=(const PRequestBuf&);
};

#endif

// end of PRequestBuf.h
